TMPDIR="/home/paradox/CDFA/data/publically_available_data/tiger/tmp"
UNZIPTOOL=unzip
WGETTOOL="/usr/bin/wget"
export PGBIN=/usr/bin
export PGPORT=5432
export PGHOST=localhost
export PGUSER=postgres
export PGPASSWORD=postgres
export PGDATABASE=california
PSQL=${PGBIN}/psql
SHP2PGSQL=${PGBIN}/shp2pgsql
cd /home/paradox/CDFA/data/publically_available_data/tiger

cd /home/paradox/CDFA/data/publically_available_data/tiger
wget ftp://ftp2.census.gov/geo/tiger/TIGER2013/PLACE/tl_*_06_* --no-parent --relative --recursive --level=2 --accept=zip --mirror --reject=html 
cd /home/paradox/CDFA/data/publically_available_data/tiger/ftp2.census.gov/geo/tiger/TIGER2013/PLACE
rm -f ${TMPDIR}/*.*
${PSQL} -c "DROP SCHEMA IF EXISTS tiger_staging CASCADE;"
${PSQL} -c "CREATE SCHEMA tiger_staging;"
for z in tl_*_06*_place.zip ; do $UNZIPTOOL -o -d $TMPDIR $z; done
for z in */tl_*_06*_place.zip ; do $UNZIPTOOL -o -d $TMPDIR $z; done
cd $TMPDIR;

${PSQL} -c "CREATE TABLE tiger_data.CA_place(CONSTRAINT pk_CA_place PRIMARY KEY (plcidfp) ) INHERITS(place);" 
${SHP2PGSQL} -c -s 4269 -g the_geom   -W "latin1" tl_2013_06_place.dbf tiger_staging.ca_place | ${PSQL}
${PSQL} -c "ALTER TABLE tiger_staging.CA_place RENAME geoid TO plcidfp;SELECT loader_load_staged_data(lower('CA_place'), lower('CA_place')); ALTER TABLE tiger_data.CA_place ADD CONSTRAINT uidx_CA_place_gid UNIQUE (gid);"
${PSQL} -c "CREATE INDEX idx_CA_place_soundex_name ON tiger_data.CA_place USING btree (soundex(name));" 
${PSQL} -c "CREATE INDEX tiger_data_CA_place_the_geom_gist ON tiger_data.CA_place USING gist(the_geom);"
${PSQL} -c "ALTER TABLE tiger_data.CA_place ADD CONSTRAINT chk_statefp CHECK (statefp = '06');"
cd /home/paradox/CDFA/data/publically_available_data/tiger
wget ftp://ftp2.census.gov/geo/tiger/TIGER2013/COUSUB/tl_*_06_* --no-parent --relative --recursive --level=2 --accept=zip --mirror --reject=html 
cd /home/paradox/CDFA/data/publically_available_data/tiger/ftp2.census.gov/geo/tiger/TIGER2013/COUSUB
rm -f ${TMPDIR}/*.*
${PSQL} -c "DROP SCHEMA IF EXISTS tiger_staging CASCADE;"
${PSQL} -c "CREATE SCHEMA tiger_staging;"
for z in tl_*_06*_cousub.zip ; do $UNZIPTOOL -o -d $TMPDIR $z; done
for z in */tl_*_06*_cousub.zip ; do $UNZIPTOOL -o -d $TMPDIR $z; done
cd $TMPDIR;

${PSQL} -c "CREATE TABLE tiger_data.CA_cousub(CONSTRAINT pk_CA_cousub PRIMARY KEY (cosbidfp), CONSTRAINT uidx_CA_cousub_gid UNIQUE (gid)) INHERITS(cousub);" 
${SHP2PGSQL} -c -s 4269 -g the_geom   -W "latin1" tl_2013_06_cousub.dbf tiger_staging.ca_cousub | ${PSQL}
${PSQL} -c "ALTER TABLE tiger_staging.CA_cousub RENAME geoid TO cosbidfp;SELECT loader_load_staged_data(lower('CA_cousub'), lower('CA_cousub')); ALTER TABLE tiger_data.CA_cousub ADD CONSTRAINT chk_statefp CHECK (statefp = '06');"
${PSQL} -c "CREATE INDEX tiger_data_CA_cousub_the_geom_gist ON tiger_data.CA_cousub USING gist(the_geom);"
${PSQL} -c "CREATE INDEX idx_tiger_data_CA_cousub_countyfp ON tiger_data.CA_cousub USING btree(countyfp);"
cd /home/paradox/CDFA/data/publically_available_data/tiger
wget ftp://ftp2.census.gov/geo/tiger/TIGER2013/TRACT/tl_*_06_* --no-parent --relative --recursive --level=2 --accept=zip --mirror --reject=html 
cd /home/paradox/CDFA/data/publically_available_data/tiger/ftp2.census.gov/geo/tiger/TIGER2013/TRACT
rm -f ${TMPDIR}/*.*
${PSQL} -c "DROP SCHEMA IF EXISTS tiger_staging CASCADE;"
${PSQL} -c "CREATE SCHEMA tiger_staging;"
for z in tl_*_06*_tract.zip ; do $UNZIPTOOL -o -d $TMPDIR $z; done
for z in */tl_*_06*_tract.zip ; do $UNZIPTOOL -o -d $TMPDIR $z; done
cd $TMPDIR;

${PSQL} -c "CREATE TABLE tiger_data.CA_tract(CONSTRAINT pk_CA_tract PRIMARY KEY (tract_id) ) INHERITS(tiger.tract); " 
${SHP2PGSQL} -c -s 4269 -g the_geom   -W "latin1" tl_2013_06_tract.dbf tiger_staging.ca_tract | ${PSQL}
${PSQL} -c "ALTER TABLE tiger_staging.CA_tract RENAME geoid TO tract_id;  SELECT loader_load_staged_data(lower('CA_tract'), lower('CA_tract')); "
	${PSQL} -c "CREATE INDEX tiger_data_CA_tract_the_geom_gist ON tiger_data.CA_tract USING gist(the_geom);"
	${PSQL} -c "VACUUM ANALYZE tiger_data.CA_tract;"
	${PSQL} -c "ALTER TABLE tiger_data.CA_tract ADD CONSTRAINT chk_statefp CHECK (statefp = '06');"
cd /home/paradox/CDFA/data/publically_available_data/tiger
wget ftp://ftp2.census.gov/geo/tiger/TIGER2013/TABBLOCK/tl_*_06_* --no-parent --relative --recursive --level=2 --accept=zip --mirror --reject=html 
cd /home/paradox/CDFA/data/publically_available_data/tiger/ftp2.census.gov/geo/tiger/TIGER2013/TABBLOCK
rm -f ${TMPDIR}/*.*
${PSQL} -c "DROP SCHEMA IF EXISTS tiger_staging CASCADE;"
${PSQL} -c "CREATE SCHEMA tiger_staging;"
for z in tl_*_06*_tabblock.zip ; do $UNZIPTOOL -o -d $TMPDIR $z; done
for z in */tl_*_06*_tabblock.zip ; do $UNZIPTOOL -o -d $TMPDIR $z; done
cd $TMPDIR;

${PSQL} -c "CREATE TABLE tiger_data.CA_tabblock(CONSTRAINT pk_CA_tabblock PRIMARY KEY (tabblock_id)) INHERITS(tiger.tabblock);" 
${SHP2PGSQL} -c -s 4269 -g the_geom   -W "latin1" tl_2013_06_tabblock.dbf tiger_staging.ca_tabblock | ${PSQL}
${PSQL} -c "ALTER TABLE tiger_staging.CA_tabblock RENAME geoid TO tabblock_id;  SELECT loader_load_staged_data(lower('CA_tabblock'), lower('CA_tabblock'), '{gid, statefp10, countyfp10, tractce10, blockce10,suffix1ce,blockce,tractce}'::text[]); "
${PSQL} -c "ALTER TABLE tiger_data.CA_tabblock ADD CONSTRAINT chk_statefp CHECK (statefp = '06');"
${PSQL} -c "CREATE INDEX tiger_data_CA_tabblock_the_geom_gist ON tiger_data.CA_tabblock USING gist(the_geom);"
${PSQL} -c "vacuum analyze tiger_data.CA_tabblock;"
cd /home/paradox/CDFA/data/publically_available_data/tiger
wget ftp://ftp2.census.gov/geo/tiger/TIGER2013/BG/tl_*_06_* --no-parent --relative --recursive --level=2 --accept=zip --mirror --reject=html 
cd /home/paradox/CDFA/data/publically_available_data/tiger/ftp2.census.gov/geo/tiger/TIGER2013/BG
rm -f ${TMPDIR}/*.*
${PSQL} -c "DROP SCHEMA IF EXISTS tiger_staging CASCADE;"
${PSQL} -c "CREATE SCHEMA tiger_staging;"
for z in tl_*_06*_bg.zip ; do $UNZIPTOOL -o -d $TMPDIR $z; done
for z in */tl_*_06*_bg.zip ; do $UNZIPTOOL -o -d $TMPDIR $z; done
cd $TMPDIR;

${PSQL} -c "CREATE TABLE tiger_data.CA_bg(CONSTRAINT pk_CA_bg PRIMARY KEY (bg_id)) INHERITS(tiger.bg);" 
${SHP2PGSQL} -c -s 4269 -g the_geom   -W "latin1" tl_2013_06_bg.dbf tiger_staging.ca_bg | ${PSQL}
${PSQL} -c "ALTER TABLE tiger_staging.CA_bg RENAME geoid TO bg_id;  SELECT loader_load_staged_data(lower('CA_bg'), lower('CA_bg')); "
${PSQL} -c "ALTER TABLE tiger_data.CA_bg ADD CONSTRAINT chk_statefp CHECK (statefp = '06');"
${PSQL} -c "CREATE INDEX tiger_data_CA_bg_the_geom_gist ON tiger_data.CA_bg USING gist(the_geom);"
${PSQL} -c "vacuum analyze tiger_data.CA_bg;"
cd /home/paradox/CDFA/data/publically_available_data/tiger
wget ftp://ftp2.census.gov/geo/tiger/TIGER2010/ZCTA5/2010/*_06* --no-parent --relative --recursive --level=2 --accept=zip --mirror --reject=html 
cd /home/paradox/CDFA/data/publically_available_data/tiger/ftp2.census.gov/geo/tiger/TIGER2010/ZCTA5/2010
rm -f ${TMPDIR}/*.*
${PSQL} -c "DROP SCHEMA IF EXISTS tiger_staging CASCADE;"
${PSQL} -c "CREATE SCHEMA tiger_staging;"
for z in tl_*_06*_zcta510.zip ; do $UNZIPTOOL -o -d $TMPDIR $z; done
for z in */tl_*_06*_zcta510.zip ; do $UNZIPTOOL -o -d $TMPDIR $z; done
cd $TMPDIR;

${PSQL} -c "CREATE TABLE tiger_data.CA_zcta5(CONSTRAINT pk_CA_zcta5 PRIMARY KEY (zcta5ce,statefp), CONSTRAINT uidx_CA_zcta5_gid UNIQUE (gid)) INHERITS(zcta5);" 
for z in *zcta510.dbf; do 
${SHP2PGSQL}  -D -s 4269 -g the_geom -W "latin1" $z tiger_staging.CA_zcta510 | ${PSQL} 
${PSQL} -c "SELECT loader_load_staged_data(lower('CA_zcta510'), lower('CA_zcta5'));"
done

${PSQL} -c "ALTER TABLE tiger_data.CA_zcta5 ADD CONSTRAINT chk_statefp CHECK (statefp = '06');"
${PSQL} -c "CREATE INDEX tiger_data_CA_zcta5_the_geom_gist ON tiger_data.CA_zcta5 USING gist(the_geom);"
cd /home/paradox/CDFA/data/publically_available_data/tiger
wget ftp://ftp2.census.gov/geo/tiger/TIGER2013/FACES/*_06* --no-parent --relative --recursive --level=2 --accept=zip --mirror --reject=html 
cd /home/paradox/CDFA/data/publically_available_data/tiger/ftp2.census.gov/geo/tiger/TIGER2013/FACES/
rm -f ${TMPDIR}/*.*
${PSQL} -c "DROP SCHEMA IF EXISTS tiger_staging CASCADE;"
${PSQL} -c "CREATE SCHEMA tiger_staging;"
for z in tl_*_06*_faces.zip ; do $UNZIPTOOL -o -d $TMPDIR $z; done
for z in */tl_*_06*_faces.zip ; do $UNZIPTOOL -o -d $TMPDIR $z; done
cd $TMPDIR;

${PSQL} -c "CREATE TABLE tiger_data.CA_faces(CONSTRAINT pk_CA_faces PRIMARY KEY (gid)) INHERITS(faces);" 
for z in *faces.dbf; do 
${SHP2PGSQL}  -D -s 4269 -g the_geom -W "latin1" $z tiger_staging.CA_faces | ${PSQL} 
${PSQL} -c "SELECT loader_load_staged_data(lower('CA_faces'), lower('CA_faces'));"
done

${PSQL} -c "CREATE INDEX tiger_data_CA_faces_the_geom_gist ON tiger_data.CA_faces USING gist(the_geom);"
	${PSQL} -c "CREATE INDEX idx_tiger_data_CA_faces_tfid ON tiger_data.CA_faces USING btree (tfid);"
	${PSQL} -c "CREATE INDEX idx_tiger_data_CA_faces_countyfp ON tiger_data.CA_faces USING btree (countyfp);"
	${PSQL} -c "ALTER TABLE tiger_data.CA_faces ADD CONSTRAINT chk_statefp CHECK (statefp = '06');"
	${PSQL} -c "vacuum analyze tiger_data.CA_faces;"
cd /home/paradox/CDFA/data/publically_available_data/tiger
wget ftp://ftp2.census.gov/geo/tiger/TIGER2013/FEATNAMES/*_06* --no-parent --relative --recursive --level=2 --accept=zip --mirror --reject=html 
cd /home/paradox/CDFA/data/publically_available_data/tiger/ftp2.census.gov/geo/tiger/TIGER2013/FEATNAMES/
rm -f ${TMPDIR}/*.*
${PSQL} -c "DROP SCHEMA IF EXISTS tiger_staging CASCADE;"
${PSQL} -c "CREATE SCHEMA tiger_staging;"
for z in tl_*_06*_featnames.zip ; do $UNZIPTOOL -o -d $TMPDIR $z; done
for z in */tl_*_06*_featnames.zip ; do $UNZIPTOOL -o -d $TMPDIR $z; done
cd $TMPDIR;

${PSQL} -c "CREATE TABLE tiger_data.CA_featnames(CONSTRAINT pk_CA_featnames PRIMARY KEY (gid)) INHERITS(featnames);ALTER TABLE tiger_data.CA_featnames ALTER COLUMN statefp SET DEFAULT '06';" 
for z in *featnames.dbf; do 
${SHP2PGSQL}  -D -s 4269 -g the_geom -W "latin1" $z tiger_staging.CA_featnames | ${PSQL} 
${PSQL} -c "SELECT loader_load_staged_data(lower('CA_featnames'), lower('CA_featnames'));"
done

${PSQL} -c "CREATE INDEX idx_tiger_data_CA_featnames_snd_name ON tiger_data.CA_featnames USING btree (soundex(name));"
${PSQL} -c "CREATE INDEX idx_tiger_data_CA_featnames_lname ON tiger_data.CA_featnames USING btree (lower(name));"
${PSQL} -c "CREATE INDEX idx_tiger_data_CA_featnames_tlid_statefp ON tiger_data.CA_featnames USING btree (tlid,statefp);"
${PSQL} -c "ALTER TABLE tiger_data.CA_featnames ADD CONSTRAINT chk_statefp CHECK (statefp = '06');"
${PSQL} -c "vacuum analyze tiger_data.CA_featnames;"
cd /home/paradox/CDFA/data/publically_available_data/tiger
wget ftp://ftp2.census.gov/geo/tiger/TIGER2013/EDGES/*_06* --no-parent --relative --recursive --level=2 --accept=zip --mirror --reject=html 
cd /home/paradox/CDFA/data/publically_available_data/tiger/ftp2.census.gov/geo/tiger/TIGER2013/EDGES/
rm -f ${TMPDIR}/*.*
${PSQL} -c "DROP SCHEMA IF EXISTS tiger_staging CASCADE;"
${PSQL} -c "CREATE SCHEMA tiger_staging;"
for z in tl_*_06*_edges.zip ; do $UNZIPTOOL -o -d $TMPDIR $z; done
for z in */tl_*_06*_edges.zip ; do $UNZIPTOOL -o -d $TMPDIR $z; done
cd $TMPDIR;

${PSQL} -c "CREATE TABLE tiger_data.CA_edges(CONSTRAINT pk_CA_edges PRIMARY KEY (gid)) INHERITS(edges);" 
for z in *edges.dbf; do 
${SHP2PGSQL}  -D -s 4269 -g the_geom -W "latin1" $z tiger_staging.CA_edges | ${PSQL} 
${PSQL} -c "SELECT loader_load_staged_data(lower('CA_edges'), lower('CA_edges'));"
done

${PSQL} -c "ALTER TABLE tiger_data.CA_edges ADD CONSTRAINT chk_statefp CHECK (statefp = '06');"
${PSQL} -c "CREATE INDEX idx_tiger_data_CA_edges_tlid ON tiger_data.CA_edges USING btree (tlid);"
${PSQL} -c "CREATE INDEX idx_tiger_data_CA_edgestfidr ON tiger_data.CA_edges USING btree (tfidr);"
${PSQL} -c "CREATE INDEX idx_tiger_data_CA_edges_tfidl ON tiger_data.CA_edges USING btree (tfidl);"
${PSQL} -c "CREATE INDEX idx_tiger_data_CA_edges_countyfp ON tiger_data.CA_edges USING btree (countyfp);"
${PSQL} -c "CREATE INDEX tiger_data_CA_edges_the_geom_gist ON tiger_data.CA_edges USING gist(the_geom);"
${PSQL} -c "CREATE INDEX idx_tiger_data_CA_edges_zipl ON tiger_data.CA_edges USING btree (zipl);"
${PSQL} -c "CREATE TABLE tiger_data.CA_zip_state_loc(CONSTRAINT pk_CA_zip_state_loc PRIMARY KEY(zip,stusps,place)) INHERITS(zip_state_loc);"
${PSQL} -c "INSERT INTO tiger_data.CA_zip_state_loc(zip,stusps,statefp,place) SELECT DISTINCT e.zipl, 'CA', '06', p.name FROM tiger_data.CA_edges AS e INNER JOIN tiger_data.CA_faces AS f ON (e.tfidl = f.tfid OR e.tfidr = f.tfid) INNER JOIN tiger_data.CA_place As p ON(f.statefp = p.statefp AND f.placefp = p.placefp ) WHERE e.zipl IS NOT NULL;"
${PSQL} -c "CREATE INDEX idx_tiger_data_CA_zip_state_loc_place ON tiger_data.CA_zip_state_loc USING btree(soundex(place));"
${PSQL} -c "ALTER TABLE tiger_data.CA_zip_state_loc ADD CONSTRAINT chk_statefp CHECK (statefp = '06');"
${PSQL} -c "vacuum analyze tiger_data.CA_edges;"
${PSQL} -c "vacuum analyze tiger_data.CA_zip_state_loc;"
${PSQL} -c "CREATE TABLE tiger_data.CA_zip_lookup_base(CONSTRAINT pk_CA_zip_state_loc_city PRIMARY KEY(zip,state, county, city, statefp)) INHERITS(zip_lookup_base);"
${PSQL} -c "INSERT INTO tiger_data.CA_zip_lookup_base(zip,state,county,city, statefp) SELECT DISTINCT e.zipl, 'CA', c.name,p.name,'06'  FROM tiger_data.CA_edges AS e INNER JOIN tiger.county As c  ON (e.countyfp = c.countyfp AND e.statefp = c.statefp AND e.statefp = '06') INNER JOIN tiger_data.CA_faces AS f ON (e.tfidl = f.tfid OR e.tfidr = f.tfid) INNER JOIN tiger_data.CA_place As p ON(f.statefp = p.statefp AND f.placefp = p.placefp ) WHERE e.zipl IS NOT NULL;"
${PSQL} -c "ALTER TABLE tiger_data.CA_zip_lookup_base ADD CONSTRAINT chk_statefp CHECK (statefp = '06');"
${PSQL} -c "CREATE INDEX idx_tiger_data_CA_zip_lookup_base_citysnd ON tiger_data.CA_zip_lookup_base USING btree(soundex(city));" 
cd /home/paradox/CDFA/data/publically_available_data/tiger
wget ftp://ftp2.census.gov/geo/tiger/TIGER2013/ADDR/*_06* --no-parent --relative --recursive --level=2 --accept=zip --mirror --reject=html 
cd /home/paradox/CDFA/data/publically_available_data/tiger/ftp2.census.gov/geo/tiger/TIGER2013/ADDR/
rm -f ${TMPDIR}/*.*
${PSQL} -c "DROP SCHEMA IF EXISTS tiger_staging CASCADE;"
${PSQL} -c "CREATE SCHEMA tiger_staging;"
for z in tl_*_06*_addr.zip ; do $UNZIPTOOL -o -d $TMPDIR $z; done
for z in */tl_*_06*_addr.zip ; do $UNZIPTOOL -o -d $TMPDIR $z; done
cd $TMPDIR;

${PSQL} -c "CREATE TABLE tiger_data.CA_addr(CONSTRAINT pk_CA_addr PRIMARY KEY (gid)) INHERITS(addr);ALTER TABLE tiger_data.CA_addr ALTER COLUMN statefp SET DEFAULT '06';" 
for z in *addr.dbf; do 
${SHP2PGSQL}  -D -s 4269 -g the_geom -W "latin1" $z tiger_staging.CA_addr | ${PSQL} 
${PSQL} -c "SELECT loader_load_staged_data(lower('CA_addr'), lower('CA_addr'));"
done

${PSQL} -c "ALTER TABLE tiger_data.CA_addr ADD CONSTRAINT chk_statefp CHECK (statefp = '06');"
	${PSQL} -c "CREATE INDEX idx_tiger_data_CA_addr_least_address ON tiger_data.CA_addr USING btree (least_hn(fromhn,tohn) );"
	${PSQL} -c "CREATE INDEX idx_tiger_data_CA_addr_tlid_statefp ON tiger_data.CA_addr USING btree (tlid, statefp);"
	${PSQL} -c "CREATE INDEX idx_tiger_data_CA_addr_zip ON tiger_data.CA_addr USING btree (zip);"
	${PSQL} -c "CREATE TABLE tiger_data.CA_zip_state(CONSTRAINT pk_CA_zip_state PRIMARY KEY(zip,stusps)) INHERITS(zip_state); "
	${PSQL} -c "INSERT INTO tiger_data.CA_zip_state(zip,stusps,statefp) SELECT DISTINCT zip, 'CA', '06' FROM tiger_data.CA_addr WHERE zip is not null;"
	${PSQL} -c "ALTER TABLE tiger_data.CA_zip_state ADD CONSTRAINT chk_statefp CHECK (statefp = '06');"
	${PSQL} -c "vacuum analyze tiger_data.CA_addr;"
